// ExListBoxView.cpp : implementation of the CExListBoxView class
//

#include "stdafx.h"
#include "ExListBox.h"

#include "ExListBoxDoc.h"
#include "ExListBoxView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CExListBoxView

IMPLEMENT_DYNCREATE(CExListBoxView, CFormView)

BEGIN_MESSAGE_MAP(CExListBoxView, CFormView)
	ON_BN_CLICKED(IDC_BUTTON_ADD, &CExListBoxView::OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_MODIFY, &CExListBoxView::OnBnClickedButtonModify)
	ON_BN_CLICKED(IDC_BUTTON_DEL, &CExListBoxView::OnBnClickedButtonDel)
	ON_BN_CLICKED(IDC_BUTTON_DELALL, &CExListBoxView::OnBnClickedButtonDelall)
	ON_LBN_SELCHANGE(IDC_LIST, &CExListBoxView::OnLbnSelchangeList)
END_MESSAGE_MAP()

// CExListBoxView construction/destruction

CExListBoxView::CExListBoxView()
	: CFormView(CExListBoxView::IDD)
{
	// TODO: add construction code here
	m_strElement = "";
}

CExListBoxView::~CExListBoxView()
{
}

void CExListBoxView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_ctrlList);
	DDX_Text(pDX, IDC_ELEMENT, m_strElement);
}

BOOL CExListBoxView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CExListBoxView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_ctrlList.ResetContent();

	//  CStringList  Ʈڽ ߰ 
	CStringList& stringList = GetDocument()->m_stringList;
	POSITION pos = stringList.GetHeadPosition();
	while (pos != NULL)
	{
		CString str = stringList.GetNext(pos);
		m_ctrlList.AddString(str);
	}
}


// CExListBoxView diagnostics

#ifdef _DEBUG
void CExListBoxView::AssertValid() const
{
	CFormView::AssertValid();
}

void CExListBoxView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CExListBoxDoc* CExListBoxView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CExListBoxDoc)));
	return (CExListBoxDoc*)m_pDocument;
}
#endif //_DEBUG


BOOL CExListBoxView::FindString(int& nSel, POSITION& pos)
{
	nSel = m_ctrlList.GetCurSel();
	if (nSel == LB_ERR)
	{
		AfxMessageBox(IDS_SELECT_STRING_FIRST);
		return FALSE;
	}

	//  Ʈڽ õ string  Ǵ 
	CString strOld;
	m_ctrlList.GetText(nSel, strOld);

	// CStringList ϴ string ã´
	CStringList& stringList = GetDocument()->m_stringList;
	pos = stringList.Find(strOld);

	//  ϴ string Ʈڽ , CStringList ־ 
	ASSERT(pos != NULL);

	return TRUE;
}

// CExListBoxView message handlers

void CExListBoxView::OnBnClickedButtonAdd()
{
	// TODO: Add your control notification handler code here
	if (UpdateData() != TRUE)
		return;

	// CStringList ο string ߰
	GetDocument()->m_stringList.AddTail(m_strElement);

	// Ʈ ڽ ο string ߰
	m_ctrlList.AddString(m_strElement);
}

void CExListBoxView::OnBnClickedButtonModify()
{
	// TODO: Add your control notification handler code here
	if (UpdateData() != TRUE)
		return;

	int nSel;
	POSITION pos;
	// CStringList Ʈڽ ϴ string Find
	if (FindString(nSel, pos) != TRUE)
		return;

	// CStringList ϴ string  Replace
	GetDocument()->m_stringList.SetAt(pos, m_strElement);

	// Ʈڽ ϴ string  Replace
	// By removing the old string and adding the new string.
	m_ctrlList.DeleteString(nSel);
	m_ctrlList.InsertString(nSel, m_strElement);
}

void CExListBoxView::OnBnClickedButtonDel()
{
	// TODO: Add your control notification handler code here
	int nSel;
	POSITION pos;

	// CStringList Ʈڽ ϴ string Find
	if (FindString(nSel, pos) != TRUE)
		return;

	// CStringList ϴ string  Delete
	GetDocument()->m_stringList.RemoveAt(pos);

	// Ʈڽ ϴ string  Delete
	m_ctrlList.DeleteString(nSel);
}

void CExListBoxView::OnBnClickedButtonDelall()
{
	// TODO: Add your control notification handler code here

	// CStringList  string Delete
	GetDocument()->m_stringList.RemoveAll();

	// Ʈڽ  string Delete
	m_ctrlList.ResetContent();
}

void CExListBoxView::OnLbnSelchangeList()
{
	// TODO: Add your control notification handler code here

	//  Ʈ Updateؼ Ʈڽ ο selection ߰Ȱ 
	m_ctrlList.GetText(m_ctrlList.GetCurSel(), m_strElement);
	UpdateData(FALSE);
}
